package it.turboApiClient.client;

import it.turboApiClient.model.Mail;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

import com.google.gson.Gson;

public class TurboApiClient {
	
	private static Logger log = Logger.getLogger(TurboApiClient.class.getName()); 
	
	public TurboApiClient(){
		PropertyConfigurator.configure("log4j.properties");
	}
	
	public String sendMail(String username, String password, String serverUrl, String jsonMailString) throws Exception {
		
		StringBuffer serverResponse = new StringBuffer();
		HttpURLConnection connection =  null;
		try {
			 
			URL url = new URL(serverUrl);
			connection = (HttpURLConnection) url.openConnection();
			connection.setDoOutput(true);
			connection.setRequestMethod("POST");
			connection.setRequestProperty("Content-Type", "application/json");
			connection.setRequestProperty("authuser", username);
			connection.setRequestProperty("authpass", password);
	 				
			OutputStream os = connection.getOutputStream();
			os.write(jsonMailString.getBytes());
			os.flush();
	 
//			if (conn.getResponseCode() != HttpURLConnection.HTTP_CREATED) {
//				throw new RuntimeException("Failed : HTTP error code : "
//					+ conn.getResponseCode());
//			}
	 
			BufferedReader br = new BufferedReader(new InputStreamReader((connection.getInputStream())));
			
			String responsePart = null;
			while ((responsePart = br.readLine()) != null) {
			
				serverResponse.append(responsePart);
			}	 
		  } catch (MalformedURLException e) {
			  
			//log.error("URL malformato!! \n", e);
			throw e;	 
		  } catch (IOException e) {
			 
			//log.error("Errore lato Server: \n", e);
			throw e;	 
		  } catch (Exception e) {
				 
				//log.error("Errore lato Server: \n", e);
				throw e;	 
		  } finally {
			  if (connection != null) {
				  connection.disconnect();
			  }			  
		  }
		  return serverResponse.toString();	 
	}

}
