package it.turboApiClient.main;

import java.io.IOException;

import javax.ws.rs.core.MediaType;

import org.apache.log4j.Logger;
import org.apache.log4j.PropertyConfigurator;

import com.google.gson.Gson;
import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.WebResource;

import it.turboApiClient.client.TurboApiClient;
import it.turboApiClient.model.Mail;

public class TurboAPIClientMain {
	
	private static Logger log = Logger.getLogger(TurboApiClient.class.getName());
	
	public TurboAPIClientMain() {
		
		PropertyConfigurator.configure("log4j.properties");
	}
	

	/**IOExceptionIOException
	 * @param args
	 */
	public static void main(String[] args) {
		
		String USERNAME         = "username;
		String PASSWORD         = "password";
		String SERVER_URL       = "https://api.turbo-smtp.com/api/v2/mail/send";
		String INCORRECT_SERVER_URL      = "https://api.turbo-smtp.com/api/mail/se";
		String FROM_MAIL_FIELD  = "from@email.com;  //insert email "from" value
		String TO_MAIL_FIELD    = "to@email.com";  //insert email "to" value
		String SUBJECT_CONTENT  = "Java Test TurboAPI Send(email) : campo SUBJECT";
		String HTML_CONTENT     = "Java Test TurboAPI Send(email) : campo HTML_CONTENT";
		        
		
		Mail mail = new Mail();
		mail.setFrom(FROM_MAIL_FIELD);
		mail.setTo(TO_MAIL_FIELD);
		mail.setSubject(SUBJECT_CONTENT);
		mail.setHtml_content(HTML_CONTENT);
		
		Gson jsonConverter = new Gson();
		String jsonMailString = jsonConverter.toJson(mail);
		
		TurboApiClient client = new TurboApiClient();
		
		String sendingMailResponse;
		try {
			sendingMailResponse = client.sendMail(USERNAME, PASSWORD, INCORRECT_SERVER_URL, jsonMailString);
			log.info("TurboAPI ha risposto con il seguente messaggio: \n\n" + sendingMailResponse);	
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
